ON_Object Class Referenceabstract

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_object.h>`

Inheritance diagram for ON_Object:

## Public Member Functions

bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const =0
virtual void | Dump (ON_TextLog &) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_BOOL32 | Write (ON_BinaryArchive &binary_archive) const
virtual ON_BOOL32 | Read (ON_BinaryArchive &binary_archive)
virtual ON::object_type | ObjectType () const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Friends

class | ON_UserData
int | ON_BinaryArchive::ReadObject (ON_Object **)
bool | ON_BinaryArchive::WriteObject (const ON_Object &)
bool | ON_BinaryArchive::ReadObjectUserData (ON_Object &)
bool | ON_BinaryArchive::WriteObjectUserData (const ON_Object &)

## Detailed Description

Definition at line 376 of file opennurbs_object.h.

## Constructor & Destructor Documentation

## ON_Object() [1/2]

ON_Object::ON_Object | ( |  | ) |

## ON_Object() [2/2]

ON_Object::ON_Object | ( | const ON_Object & |  | ) |

## ~ON_Object()

virtual ON_Object::~ON_Object | ( |  | ) |

virtual

## Member Function Documentation

## AttachUserData()

ON_BOOL32 ON_Object::AttachUserData | ( | ON_UserData * | pUserData | ) |

## CopyFrom()

bool ON_Object::CopyFrom | ( | const ON_Object * | src | ) |

## CopyUserData()

void ON_Object::CopyUserData | ( | const ON_Object & | source_object | ) |

## DataCRC()

virtual ON__UINT32 ON_Object::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented in ON_Brep, ON_NurbsCage, ON_BrepFace, ON_Mesh, ON_ClippingPlaneSurface, ON_DocumentUserStringList, ON_UserStringList, ON_BrepEdge, ON_SumSurface, ON_NurbsSurface, ON_RevSurface, ON_NurbsCurve, ON_BrepVertex, ON_SurfaceProxy, ON_PolyCurve, ON_CurveProxy, ON_PlaneSurface, ON_Extrusion, ON_ArcCurve, ON_LineCurve, and ON_PolylineCurve.

## DestroyRuntimeCache()

virtual void ON_Object::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented in ON_MorphControl, ON_Brep, ON_NurbsCage, ON_Mesh, ON_BrepFace, ON_BrepLoop, ON_BrepTrim, ON_PolyEdgeSegment, ON_Curve, ON_Surface, ON_CurveProxy, ON_PolyCurve, ON_PolyEdgeCurve, ON_SurfaceProxy, ON_SumSurface, and ON_RevSurface.

## DetachUserData()

ON_BOOL32 ON_Object::DetachUserData | ( | ON_UserData * | pUserData | ) |

## Dump()

virtual void ON_Object::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_TextDot, ON_Brep, ON_MorphControl, ON_NurbsCage, ON_BrepFace, ON_Mesh, ON_BrepLoop, ON_ClippingPlaneSurface, ON_Hatch, ON_BrepTrim, ON_DocumentUserStringList, ON_HatchPattern, ON_BrepEdge, ON_UserStringList, ON_NurbsSurface, ON_UnknownUserData, ON_CurveProxy, ON_Annotation, ON_NurbsCurve, ON_DimensionExtra, ON_SumSurface, ON_ArcCurve, ON_RevSurface, ON_PolyCurve, ON_AnnotationArrow, ON_BrepVertex, ON_TextExtra, ON_InstanceDefinition, ON_HistoryRecord, ON_SurfaceProxy, ON_Font, ON_Viewport, ON_CurveOnSurface, ON_PlaneSurface, ON_PointGrid, ON_PolylineCurve, ON_LineCurve, ON_Point, ON_DimStyle, ON_Linetype, ON_PointCloud, ON_Material, ON_UserData, ON_AnnotationTextDot, ON_Light, ON_Layer, ON_Group, ON_TextureMapping, ON_3dmObjectAttributes, ON_Extrusion, ON_Texture, ON_Bitmap, and ON_DetailView.

## EmergencyDestroy()

void ON_Object::EmergencyDestroy | ( |  | ) |

## FirstUserData()

ON_UserData* ON_Object::FirstUserData | ( |  | ) | const

## GetUserData()

ON_UserData* ON_Object::GetUserData | ( | const ON_UUID & | userdata_uuid | ) | const

## GetUserString()

bool ON_Object::GetUserString | ( | const wchar_t * | key,
|  | ON_wString & | string_value
| ) |  | const

## GetUserStringKeys()

int ON_Object::GetUserStringKeys | ( | ON_ClassArray< ON_wString > & | user_string_keys | ) | const

## GetUserStrings()

int ON_Object::GetUserStrings | ( | ON_ClassArray< ON_UserString > & | user_strings | ) | const

## IsKindOf()

ON_BOOL32 ON_Object::IsKindOf | ( | const ON_ClassId * | pClassId | ) | const

## IsValid()

virtual ON_BOOL32 ON_Object::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

pure virtual

Implemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_TextDot, ON_Leader2, ON_TextEntity2, ON_OrdinateDimension2, ON_Brep, ON_MorphControl, ON_AngularDimension2, ON_BrepRegion, ON_RadialDimension2, ON_BrepFaceSide, ON_LinearDimension2, ON_NurbsCage, ON_BrepFace, ON_Mesh, ON_BrepLoop, ON_EmbeddedBitmap, ON_Hatch, ON_BrepTrim, ON_InstanceRef, ON_DocumentUserStringList, ON_WindowsBitmap, ON_UserDataHolder, ON_HatchPattern, ON_Annotation2, ON_BrepEdge, ON_NurbsSurface, ON_UnknownUserData, ON_CurveProxy, ON_Annotation, ON_NurbsCurve, ON_EmbeddedFile, ON_SumSurface, ON_ArcCurve, ON_RevSurface, ON_AnnotationArrow, ON_BrepVertex, ON_InstanceDefinition, ON_HistoryRecord, ON_SurfaceProxy, ON_PolyCurve, ON_CurveOnSurface, ON_Font, ON_PlaneSurface, ON_PointGrid, ON_Viewport, ON_LineCurve, ON_Point, ON_PolylineCurve, ON_DimStyle, ON_Linetype, ON_Material, ON_PointCloud, ON_AnnotationTextDot, ON_Light, ON_Layer, ON_Group, ON_UserData, ON_TextureMapping, ON_3dmObjectAttributes, ON_Extrusion, ON_Texture, and ON_DetailView.

## MemoryRelocate()

virtual void ON_Object::MemoryRelocate | ( |  | ) |

virtual

Reimplemented in ON_MorphControl, ON_Brep, ON_Mesh, and ON_DetailView.

## ModelObjectId()

virtual ON_UUID ON_Object::ModelObjectId | ( |  | ) | const

virtual

Reimplemented in ON_HatchPattern, ON_InstanceDefinition, ON_HistoryRecord, ON_Font, ON_Linetype, ON_DimStyle, ON_Material, ON_Light, ON_TextureMapping, ON_Layer, and ON_Bitmap.

## MoveUserData()

void ON_Object::MoveUserData | ( | ON_Object & | source_object | ) |

## ObjectType()

virtual ON::object_type ON_Object::ObjectType | ( |  | ) | const

virtual

Reimplemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_TextDot, ON_Brep, ON_MorphControl, ON_NurbsCage, ON_Mesh, ON_ClippingPlaneSurface, ON_Hatch, ON_InstanceRef, ON_Annotation2, ON_BrepEdge, ON_Annotation, ON_Curve, ON_AnnotationArrow, ON_InstanceDefinition, ON_Surface, ON_PointGrid, ON_Point, ON_Material, ON_PointCloud, ON_Light, ON_Layer, ON_Extrusion, and ON_DetailView.

## operator=()

ON_Object& ON_Object::operator= | ( | const ON_Object & |  | ) |

## PurgeUserData()

void ON_Object::PurgeUserData | ( |  | ) |

## Read()

virtual ON_BOOL32 ON_Object::Read | ( | ON_BinaryArchive & | binary_archive | ) |

virtual

Reimplemented in ON_TextDot, ON_Leader2, ON_TextEntity2, ON_Brep, ON_OrdinateDimension2, ON_MorphControl, ON_AngularDimension2, ON_BrepRegion, ON_BrepFaceSide, ON_RadialDimension2, ON_NurbsCage, ON_LinearDimension2, ON_BrepFace, ON_Mesh, ON_BrepLoop, ON_ClippingPlaneSurface, ON_EmbeddedBitmap, ON_WindowsBitmapEx, ON_Hatch, ON_BrepTrim, ON_InstanceRef, ON_DocumentUserStringList, ON_WindowsBitmap, ON_TextEntity, ON_AngularDimension, ON_HatchPattern, ON_Annotation2, ON_BrepEdge, ON_UserStringList, ON_NurbsSurface, ON_UnknownUserData, ON_CurveProxy, ON_NurbsCurve, ON_Annotation, ON_EmbeddedFile, ON_DimensionExtra, ON_SumSurface, ON_PolyEdgeSegment, ON_ArcCurve, ON_RevSurface, ON_PolyCurve, ON_AnnotationArrow, ON_Viewport, ON_TextExtra, ON_BrepVertex, ON_InstanceDefinition, ON_SurfaceProxy, ON_HistoryRecord, ON_Font, ON_CurveOnSurface, ON_PlaneSurface, ON_PolylineCurve, ON_Linetype, ON_PointGrid, ON_DimStyle, ON_LineCurve, ON_Point, ON_PointCloud, ON_Material, ON_Light, ON_TextureMapping, ON_AnnotationTextDot, ON_Layer, ON_Group, ON_3dmObjectAttributes, ON_Texture, ON_Extrusion, and ON_DetailView.

## SetUserString()

bool ON_Object::SetUserString | ( | const wchar_t * | key,
|  | const wchar_t * | string_value
| ) |  |

## SetUserStrings()

int ON_Object::SetUserStrings | ( | int | count,
|  | const ON_UserString * | user_strings,
|  | bool | bReplace
| ) |  |

## SizeOf()

virtual unsigned int ON_Object::SizeOf | ( |  | ) | const

virtual

Reimplemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_MorphControl, ON_Brep, ON_NurbsCage, ON_BrepFace, ON_Mesh, ON_BrepLoop, ON_ClippingPlaneSurface, ON_BrepTrim, ON_UserStringList, ON_BrepEdge, ON_UnknownUserData, ON_DimensionExtra, ON_SumSurface, ON_Curve, ON_InstanceDefinition, ON_NurbsSurface, ON_TextExtra, ON_RevSurface, ON_Surface, ON_NurbsCurve, ON_BrepVertex, ON_SurfaceProxy, ON_UserData, ON_PolyCurve, ON_CurveProxy, ON_TextureMapping, ON_3dmObjectAttributes, ON_Extrusion, ON_CurveOnSurface, ON_PlaneSurface, ON_Texture, ON_ArcCurve, ON_LineCurve, ON_PolylineCurve, and ON_DetailView.

## TransformUserData()

void ON_Object::TransformUserData | ( | const ON_Xform & | xform | ) |

## UserStringCount()

int ON_Object::UserStringCount | ( |  | ) | const

## Write()

virtual ON_BOOL32 ON_Object::Write | ( | ON_BinaryArchive & | binary_archive | ) | const

virtual

Reimplemented in ON_TextDot, ON_Leader2, ON_TextEntity2, ON_Brep, ON_OrdinateDimension2, ON_MorphControl, ON_AngularDimension2, ON_BrepRegion, ON_BrepFaceSide, ON_RadialDimension2, ON_NurbsCage, ON_LinearDimension2, ON_BrepFace, ON_Mesh, ON_BrepLoop, ON_ClippingPlaneSurface, ON_EmbeddedBitmap, ON_WindowsBitmapEx, ON_Hatch, ON_BrepTrim, ON_DocumentUserStringList, ON_InstanceRef, ON_WindowsBitmap, ON_TextEntity, ON_AngularDimension, ON_HatchPattern, ON_Annotation2, ON_BrepEdge, ON_UserStringList, ON_NurbsSurface, ON_UnknownUserData, ON_CurveProxy, ON_NurbsCurve, ON_Annotation, ON_EmbeddedFile, ON_DimensionExtra, ON_SumSurface, ON_PolyEdgeSegment, ON_ArcCurve, ON_RevSurface, ON_PolyCurve, ON_AnnotationArrow, ON_TextExtra, ON_BrepVertex, ON_InstanceDefinition, ON_HistoryRecord, ON_SurfaceProxy, ON_Viewport, ON_Font, ON_CurveOnSurface, ON_PlaneSurface, ON_PolylineCurve, ON_PointGrid, ON_Linetype, ON_DimStyle, ON_LineCurve, ON_Point, ON_PointCloud, ON_Material, ON_Light, ON_TextureMapping, ON_AnnotationTextDot, ON_Layer, ON_3dmObjectAttributes, ON_Group, ON_Extrusion, ON_Texture, and ON_DetailView.

## Friends And Related Function Documentation

## ON_BinaryArchive::ReadObject

int ON_BinaryArchive::ReadObject | ( | ON_Object ** |  | ) |

friend

## ON_BinaryArchive::ReadObjectUserData

bool ON_BinaryArchive::ReadObjectUserData | ( | ON_Object & |  | ) |

friend

## ON_BinaryArchive::WriteObject

bool ON_BinaryArchive::WriteObject | ( | const ON_Object & |  | ) |

friend

## ON_BinaryArchive::WriteObjectUserData

bool ON_BinaryArchive::WriteObjectUserData | ( | const ON_Object & |  | ) |

friend

## ON_UserData

friend class ON_UserData

friend

Definition at line 858 of file opennurbs_object.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_object.h